"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const git_1 = require("../utils/git");
const runner_1 = require("../utils/runner");
const yarn_1 = require("../utils/yarn");
const ciResolver_1 = require("../resolvers/ciResolver");
const db_1 = require("../db");
const cacheResolver_1 = require("../resolvers/cacheResolver");
const testResolver_1 = require("../resolvers/testResolver");
const flow_1 = require("../flow");
const lts_1 = require("../utils/lts");
const packageInfo_1 = require("../utils/packageInfo");
const nodeModulesContainer_1 = require("./nodeModulesContainer");
const enginesResolver_1 = require("../resolvers/enginesResolver");
const logger_1 = require("../utils/logger");
exports.container = new inversify_1.Container();
const binders = [
    git_1.gitModuleBinder,
    nodeModulesContainer_1.nodeModulesBinder,
    runner_1.runnerModuleBinder,
    yarn_1.yarnModulesBinder,
    ciResolver_1.ciResolverModulesBinder,
    db_1.dbModulesBinder,
    cacheResolver_1.cacheResolveModulesBinder,
    testResolver_1.testResolverModulesBinder,
    flow_1.flowModulesBinder,
    lts_1.ltsModulesBinder,
    packageInfo_1.packageInfoModulesBinder,
    enginesResolver_1.enginesResolveModulesBinder,
    logger_1.loggerModuleBinder,
];
exports.container.load(new inversify_1.ContainerModule((bind) => {
    binders.forEach((binder) => {
        binder(bind);
    });
}));
