"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const path = require("path");
const memoize_1 = require("../../utils/memoize/memoize");
const connectionProvider_1 = require("../interfaces/connectionProvider");
const connectionSettings_1 = require("../interfaces/connectionSettings");
const nodeModulesContainer_1 = require("../../container/nodeModulesContainer");
const entity_1 = require("../interfaces/entity");
const DB_FILE = `cache.db`;
let ConnectionProvider = class ConnectionProvider extends connectionProvider_1.IConnectionProvider {
    constructor(settings, typeorm, entities) {
        super();
        this.settings = settings;
        this.typeorm = typeorm;
        this.entities = entities;
    }
    async getConnection() {
        return await this.typeorm.createConnection({
            name: this.settings.databaseFilePath,
            type: `sqlite`,
            database: path.join(this.settings.databaseFilePath, DB_FILE),
            synchronize: true,
            logging: false,
            dropSchema: this.settings.dropSchema,
            entities: this.entities,
        });
    }
};
__decorate([
    memoize_1.memoize(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ConnectionProvider.prototype, "getConnection", null);
ConnectionProvider = __decorate([
    inversify_1.injectable(),
    __param(1, inversify_1.inject(nodeModulesContainer_1.TYPES.TypeOrm)),
    __param(2, inversify_1.multiInject(entity_1.IEntity)),
    __metadata("design:paramtypes", [connectionSettings_1.IConnectionSettings, Object, Array])
], ConnectionProvider);
exports.ConnectionProvider = ConnectionProvider;
