"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const dependencyVersion_1 = require("../entities/dependencyVersion");
const dependencyVersionRepositoryProvider_1 = require("../interfaces/dependencyVersionRepositoryProvider");
const memoize_1 = require("../../utils/memoize/memoize");
const connectionProvider_1 = require("../interfaces/connectionProvider");
let DependencyVersionRepositoryProvider = class DependencyVersionRepositoryProvider extends dependencyVersionRepositoryProvider_1.IDependencyVersionRepositoryProvider {
    constructor(connectionProvider) {
        super();
        this.connectionProvider = connectionProvider;
    }
    async getRepository() {
        const connection = await this.connectionProvider.getConnection();
        return connection.getRepository(dependencyVersion_1.DependencyVersion);
    }
};
__decorate([
    memoize_1.memoize(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], DependencyVersionRepositoryProvider.prototype, "getRepository", null);
DependencyVersionRepositoryProvider = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [connectionProvider_1.IConnectionProvider])
], DependencyVersionRepositoryProvider);
exports.DependencyVersionRepositoryProvider = DependencyVersionRepositoryProvider;
