"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const dependencyRepositoryProvider_1 = require("./impl/dependencyRepositoryProvider");
const dependencyRepositoryProvider_2 = require("./interfaces/dependencyRepositoryProvider");
const connectionProvider_1 = require("./impl/connectionProvider");
const dependencyVersionRepositoryProvider_1 = require("./impl/dependencyVersionRepositoryProvider");
const dependencyVersionRepositoryProvider_2 = require("./interfaces/dependencyVersionRepositoryProvider");
const connectionProvider_2 = require("./interfaces/connectionProvider");
const entity_1 = require("./interfaces/entity");
const dependency_1 = require("./entities/dependency");
const dependencyVersion_1 = require("./entities/dependencyVersion");
exports.dbModulesBinder = (bind) => {
    bind(dependencyRepositoryProvider_2.IDependencyRepositoryProvider)
        .to(dependencyRepositoryProvider_1.DependencyRepositoryProvider)
        .inSingletonScope();
    bind(dependencyVersionRepositoryProvider_2.IDependencyVersionRepositoryProvider)
        .to(dependencyVersionRepositoryProvider_1.DependencyVersionRepositoryProvider)
        .inSingletonScope();
    bind(connectionProvider_2.IConnectionProvider)
        .to(connectionProvider_1.ConnectionProvider)
        .inSingletonScope();
    bind(entity_1.IEntity).toConstantValue(dependency_1.Dependency);
    bind(entity_1.IEntity).toConstantValue(dependencyVersion_1.DependencyVersion);
};
__export(require("./interfaces/connectionProvider"));
__export(require("./interfaces/dependencyRepositoryProvider"));
__export(require("./interfaces/dependencyVersionRepositoryProvider"));
__export(require("./interfaces/connectionSettings"));
__export(require("./entities/dependency"));
__export(require("./entities/dependencyVersion"));
