"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const cacheResolver_1 = require("../interfaces/cacheResolver");
const db_1 = require("../../../db");
let CacheResolver = class CacheResolver extends cacheResolver_1.ICacheResolver {
    constructor(dependencyRepositoryProvider) {
        super();
        this.dependencyRepositoryProvider = dependencyRepositoryProvider;
    }
    async resolve({ repo, targetNode }) {
        try {
            const dependencyRepository = await this.dependencyRepositoryProvider.getRepository();
            const dependency = await dependencyRepository.findOne({
                name: repo.name,
                version: repo.version,
                targetNode,
            });
            if (dependency && dependency.match) {
                return {
                    isMatch: true,
                    resolverName: `${dependency.reason} (cache)`,
                };
            }
        }
        catch (e) { }
        return {
            isMatch: false,
        };
    }
};
CacheResolver = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [db_1.IDependencyRepositoryProvider])
], CacheResolver);
exports.CacheResolver = CacheResolver;
