"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const cIResolver_1 = require("../interfaces/cIResolver");
const inversify_1 = require("inversify");
const specificCIResolver_1 = require("../interfaces/specificCIResolver");
const targetMatcher_1 = require("../interfaces/targetMatcher");
let CiResolver = class CiResolver extends cIResolver_1.ICIResolver {
    constructor(resolvers, targetMatcher) {
        super();
        this.resolvers = resolvers;
        this.targetMatcher = targetMatcher;
    }
    async resolve({ repoPath, targetNode, packageReleaseDate }) {
        for (const resolver of this.resolvers) {
            let nodeVersions;
            try {
                nodeVersions = await resolver.resolve({
                    repoPath,
                });
            }
            catch (e) {
                console.log(`Failed to find node versions in resolver ${resolver.resolverName} due to an unknown error`, e);
            }
            if (nodeVersions) {
                if (nodeVersions.length === 0) {
                    console.log(`Failed to find node versions in resolver ${resolver.resolverName}`);
                }
                else {
                    const isMatch = await this.targetMatcher.match({
                        candidates: nodeVersions,
                        targetNode,
                        packageReleaseDate,
                    });
                    if (isMatch) {
                        return {
                            isMatch: true,
                            resolverName: resolver.resolverName,
                        };
                    }
                }
            }
        }
        return {
            isMatch: false,
        };
    }
};
CiResolver = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.multiInject(specificCIResolver_1.ISpecificCIResolver)),
    __metadata("design:paramtypes", [Array, targetMatcher_1.ITargetMatcher])
], CiResolver);
exports.CiResolver = CiResolver;
