"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const specificCIResolver_1 = require("../../interfaces/specificCIResolver");
const inversify_1 = require("inversify");
const nodeModulesContainer_1 = require("../../../../container/nodeModulesContainer");
const yaml_1 = require("yaml");
const ciFileName = `.travis.yml`;
const resolverName = `travisCi`;
const ltsMapper = (nodeVersion) => {
    if (nodeVersion === `lts/*`) {
        return specificCIResolver_1.LTS_VERSION;
    }
    return nodeVersion;
};
let TravisCiResolver = class TravisCiResolver extends specificCIResolver_1.ISpecificCIResolver {
    constructor(fs) {
        super();
        this.fs = fs;
        this.resolverName = resolverName;
    }
    async resolve({ repoPath }) {
        const fileName = path.join(repoPath, ciFileName);
        let fileContents;
        try {
            fileContents = await this.fs.promises.readFile(fileName, `utf-8`);
        }
        catch (e) {
            return;
        }
        const yaml = yaml_1.parse(fileContents);
        const versions = yaml.node_js;
        return versions.map(ltsMapper);
    }
};
TravisCiResolver = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject(nodeModulesContainer_1.TYPES.FS)),
    __metadata("design:paramtypes", [Object])
], TravisCiResolver);
exports.TravisCiResolver = TravisCiResolver;
