"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const cIResolver_1 = require("./interfaces/cIResolver");
const ciResolver_1 = require("./impl/ciResolver");
const specificCIResolver_1 = require("./interfaces/specificCIResolver");
const travis_1 = require("./impl/resolvers/travis");
const circle_1 = require("./impl/resolvers/circle");
const github_1 = require("./impl/resolvers/github");
const targetMatcher_1 = require("./interfaces/targetMatcher");
const targetMatcher_2 = require("./impl/targetMatcher");
const appveyor_1 = require("./impl/resolvers/appveyor");
exports.ciResolverModulesBinder = (bind) => {
    bind(cIResolver_1.ICIResolver)
        .to(ciResolver_1.CiResolver)
        .inSingletonScope();
    bind(targetMatcher_1.ITargetMatcher)
        .to(targetMatcher_2.TargetMatcher)
        .inSingletonScope();
    bind(specificCIResolver_1.ISpecificCIResolver)
        .to(travis_1.TravisCiResolver)
        .inSingletonScope();
    bind(specificCIResolver_1.ISpecificCIResolver)
        .to(appveyor_1.AppVeyorResolver)
        .inSingletonScope();
    bind(specificCIResolver_1.ISpecificCIResolver)
        .to(circle_1.CircleCiResolver)
        .inSingletonScope();
    bind(specificCIResolver_1.ISpecificCIResolver)
        .to(github_1.GithubActionsResolver)
        .inSingletonScope();
};
__export(require("./interfaces/specificCIResolver"));
__export(require("./interfaces/targetMatcher"));
__export(require("./interfaces/cIResolver"));
