"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const testResolver_1 = require("../interfaces/testResolver");
const yarn_1 = require("../../../utils/yarn");
const resolverName = `yarn run test`;
let TestResolver = class TestResolver extends testResolver_1.ITestResolver {
    constructor(yarn) {
        super();
        this.yarn = yarn;
    }
    async resolve({ repoPath }) {
        try {
            const yarnOptions = {
                cwd: repoPath,
            };
            await this.yarn.install(yarnOptions);
            await this.yarn.build(yarnOptions);
            await this.yarn.test(yarnOptions);
            return {
                isMatch: true,
                resolverName,
            };
        }
        catch (e) { }
        return {
            isMatch: false,
        };
    }
};
TestResolver = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [yarn_1.IYarn])
], TestResolver);
exports.TestResolver = TestResolver;
