import { SimpleGitFn } from '../../../container/nodeModulesContainer';
import { ILoggerFactory } from '../../logger';
import { SimpleGit } from 'simple-git/promise';
export interface ICheckoutCommitOptions {
    repo: SimpleGit;
    commitSha: string;
}
export interface CloneRepoOptions {
    url: string;
    dir: string;
}
export interface ILocateTagOptions {
    repo: SimpleGit;
    tag: string;
}
export interface IOpenRepoOptions {
    path: string;
}
export declare class Git {
    private readonly git;
    private readonly logger;
    constructor(git: SimpleGitFn, loggerFactory: ILoggerFactory);
    checkoutCommit({ repo, commitSha }: ICheckoutCommitOptions): Promise<void>;
    cloneRepo({ url, dir }: CloneRepoOptions): Promise<SimpleGit>;
    locateTag({ repo, tag }: ILocateTagOptions): Promise<string>;
    openRepo({ path }: IOpenRepoOptions): Promise<SimpleGit>;
}
