"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
const consola_1 = require("consola");
// eslint-disable-next-line @typescript-eslint/quotes
const chalk = require("chalk");
const figures = require("figures");
const bgColorCache = {};
const chalkBgColor = (name) => {
    let color = bgColorCache[name];
    if (color) {
        return color;
    }
    // @ts-ignore
    color = chalk[`bg${name[0].toUpperCase()}${name.slice(1)}`];
    bgColorCache[name] = color;
    return color;
};
const LEVEL_COLOR_MAP = {
    0: `red`,
    1: `yellow`,
    2: `white`,
    3: `green`,
};
const TYPE_COLOR_MAP = {
    info: `blue`,
};
const TYPE_ICONS = {
    info: figures(`ℹ`),
    success: figures(`✔`),
    error: figures(`✖`),
    warn: figures(`Ⓘ`),
};
class LogReporter extends consola_1.FancyReporter {
    constructor(options) {
        super(options);
    }
    formatType(logObj) {
        // @ts-ignore
        const typeColor = TYPE_COLOR_MAP[logObj.type] || LEVEL_COLOR_MAP[logObj.level] || this.options.secondaryColor;
        // @ts-ignore
        const typeIcon = TYPE_ICONS[logObj.type];
        const text = ` ${typeIcon || logObj.type.toUpperCase()} `;
        return chalkBgColor(typeColor).black(text);
    }
    log(logObj, args) {
        super.log(logObj, args);
    }
}
exports.LogReporter = LogReporter;
