"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const consola_1 = require("consola");
const logger_1 = require("../interfaces/logger");
class Logger extends consola_1.Consola {
    constructor(options) {
        super(options);
    }
    isLevelEnabled(level) {
        return this.level >= level;
    }
    isTraceEnabled() {
        return this.isLevelEnabled(logger_1.LogLevel.TRACE);
    }
    isDebugEnabled() {
        return this.isLevelEnabled(logger_1.LogLevel.DEBUG);
    }
    isInfoEnabled() {
        return this.isLevelEnabled(logger_1.LogLevel.INFO);
    }
    isWarnEnabled() {
        return this.isLevelEnabled(logger_1.LogLevel.WARN);
    }
}
exports.Logger = Logger;
