"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const loggerFactory_1 = require("../interfaces/loggerFactory");
const memoize_1 = require("../../memoize/memoize");
const loggerSettings_1 = require("../interfaces/loggerSettings");
const chalk = require("chalk");
const logger_1 = require("../interfaces/logger");
const logger_2 = require("./logger");
const logReporter_1 = require("./logReporter");
let LoggerFactory = class LoggerFactory extends loggerFactory_1.ILoggerFactory {
    constructor(settings) {
        super();
        const isDebug = settings.debugMode;
        const isTrace = settings.traceMode;
        const level = isTrace ? logger_1.LogLevel.TRACE : isDebug ? logger_1.LogLevel.DEBUG : logger_1.LogLevel.INFO;
        this.options = {
            level,
            reporters: [new logReporter_1.LogReporter()],
        };
    }
    getLogger(category) {
        return new logger_2.Logger({
            ...this.options,
            defaults: {
                message: `${chalk.cyan(category)}`,
            },
        });
    }
};
__decorate([
    memoize_1.memoize((category) => category),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Object)
], LoggerFactory.prototype, "getLogger", null);
LoggerFactory = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [loggerSettings_1.ILoggerSettings])
], LoggerFactory);
exports.LoggerFactory = LoggerFactory;
