"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const lts_1 = require("../interfaces/lts");
// eslint-disable-next-line @typescript-eslint/quotes
const moment = require("moment");
const dateFormat = `YYYY-MM-DD`;
// taken from https://en.wikipedia.org/wiki/Node.js
const nodesByDate = [
    {
        version: `4`,
        from: moment.utc(`2015-10-01`, dateFormat),
        to: moment.utc(`2018-04-30`, dateFormat),
    },
    {
        version: `6`,
        from: moment.utc(`2016-10-18`, dateFormat),
        to: moment.utc(`2019-04-30`, dateFormat),
    },
    {
        version: `8`,
        from: moment.utc(`2017-10-31`, dateFormat),
        to: moment.utc(`2019-12-31`, dateFormat),
    },
    {
        version: `10`,
        from: moment.utc(`2018-10-30`, dateFormat),
        to: moment.utc(`2021-04-01`, dateFormat),
    },
    {
        version: `12`,
        from: moment.utc(`2019-10-22`, dateFormat),
        to: moment.utc(`2022-04-01`, dateFormat),
    },
    {
        version: `14`,
        from: moment.utc(`2020-10-20`, dateFormat),
        to: moment.utc(`2023-04-30`, dateFormat),
    },
];
let Lts = class Lts extends lts_1.ILts {
    constructor() {
        super();
    }
    async resolveLtsVersion({ date }) {
        return nodesByDate
            .filter((lts) => {
            return lts.from.isBefore(date) && lts.to.isAfter(date);
        })
            .map((lts) => {
            return lts.version;
        });
    }
};
Lts = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [])
], Lts);
exports.Lts = Lts;
