"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const runner_1 = require("../../runner");
const yarn_1 = require("../interfaces/yarn");
const inversify_1 = require("inversify");
const logger_1 = require("../../logger");
let Yarn = class Yarn extends yarn_1.IYarn {
    constructor(runner, loggerFactory) {
        super();
        this.runner = runner;
        this.logger = loggerFactory.getLogger(`Yarn`);
    }
    async install({ cwd }) {
        this.logger.info(`Running yarn install`);
        await this.runner.executeCommand({
            command: [`yarn`, `install`],
            execOptions: {
                cwd,
            },
        });
        this.logger.success(`yarn install ran successfully`);
    }
    async build({ cwd }) {
        this.logger.info(`Running yarn build`);
        await this.runner.executeCommand({
            command: [`yarn`, `run`, `build`],
            execOptions: {
                cwd,
            },
        });
        this.logger.success(`yarn build ran successfully`);
    }
    async test({ cwd }) {
        this.logger.info(`Running yarn test`);
        await this.runner.executeCommand({
            command: [`yarn`, `run`, `test`],
            execOptions: {
                cwd,
            },
        });
        this.logger.success(`yarn test ran successfully`);
    }
};
Yarn = __decorate([
    inversify_1.injectable(),
    __metadata("design:paramtypes", [runner_1.IRunner, logger_1.ILoggerFactory])
], Yarn);
exports.Yarn = Yarn;
